package net.risesoft.demo;

import java.lang.reflect.Method;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

public class Example {

	public static void main(String[] args) {
		Car car = new Car();
		System.out.println("当前车辆版本： " + car.getVersion());
		System.out.println("当前 jar 包路径 ： ");
		System.out.println(car.getClass().getProtectionDomain().getCodeSource().getLocation().getPath());
		Method[] declaredMethods = car.getClass().getDeclaredMethods();
		for (Method declaredMethod : declaredMethods) {
			System.out.println("------------------");
			System.out.println("method name: " + declaredMethod.getName());
			List<String> collect = Arrays.stream(declaredMethod.getParameterTypes()).map(Class::getName).collect(Collectors
					.toList());
			if (!collect.isEmpty()) {
				System.out.println("parameter type : " + collect);
			}
			System.out.println("------------------");
		}
	}

}
